﻿namespace ClientPrism;

interface

uses
  CookComputing.XmlRpc,
  System.Text;

type
  ConsoleApp = class
  public
    class method Main;
  end;

implementation

class method ConsoleApp.Main;
begin
  var servicos := XmlRpcProxyGen.Create<IServicos>;
  
  // chama método remoto FormatarNome
  Console.WriteLine();
  Console.WriteLine('Método FormatarNome:');
  var naoFormatado := 'mIgUeL    hEnLEY';
  var formatado := servicos.FormatarNome(naoFormatado);
  Console.WriteLine('Nao formatado: ' + naoFormatado);
  Console.WriteLine('Formatado    : ' + formatado);
  Console.WriteLine('---------------------------------------------------------');
  Console.WriteLine();
  
  // chama método para calcular o numero PI
  Console.WriteLine('Método ObterPI: (50 casas decimais)');
  var pi := servicos.ObterPI(50);
  Console.WriteLine('Pi = ' + pi);
  Console.WriteLine('---------------------------------------------------------');
  Console.WriteLine();
  

  // chama método para obter as fases da lua:
  Console.WriteLine('Método ObterFasesLua: (maio/2009)');
  Console.WriteLine('formato dia/mes/ano=[0-7]. 0=lua cheia, 7=lua nova');
  Console.WriteLine();
  var mes := 5;
  var ano := 2009;
  var fases := servicos.ObterFasesLua(mes, ano);
  var strbuilder := new StringBuilder();

  var dia := 1;
  for each fase: String in fases do
  begin
    if dia <> 1 then
      strbuilder.append('; ');

    strbuilder.append(dia).append('/').append(mes).append('/').append(ano).append('=').
        append(fase);
    
    inc(dia);
  end;

  Console.WriteLine(strbuilder);
  Console.WriteLine('---------------------------------------------------------');
  Console.WriteLine();

  {
  // chama método para fazer um post no Twitter:
  Console.WriteLine('Fazendo um post no twitter');
  var ok := servicos.PostarTwitter('login-twitter', 'senha-twitter', 'bla bla bla');
  }

  Console.WriteLine();
  Console.ReadLine();

end;

end.