package com.henley;

import winterwell.jtwitter.Twitter;

import java.util.regex.PatternSyntaxException;
import java.util.regex.Pattern;
import java.util.regex.Matcher;
import java.util.Calendar;

/**
 * Created by IntelliJ IDEA.
 * User: henley
 * Date: 18/05/2009
 * Time: 14:23:29
 * To change this template use File | Settings | File Templates.
 */
public class Servicos {
    public String formatarNome(String uglyFormat) throws Exception {

        if ((uglyFormat == null) || (uglyFormat.trim().equals(""))) {
            throw new Exception("Nome no pode estar em branco");
        }

        String nome = uglyFormat.trim();
        StringBuffer fmt = new StringBuffer();
        String[] split = new String[0];

        try {
            split = nome.split("(?im) +");
        } catch (PatternSyntaxException ex) {
            // ignorar - a regex  constante e vlida!!! :-)
        }

        Pattern exceptions = Pattern.compile("da|de|di|do|du", Pattern.CASE_INSENSITIVE |
                Pattern.UNICODE_CASE | Pattern.MULTILINE);

        for (String parte : split) {
            Matcher matcher = exceptions.matcher(parte);

            if (matcher.matches()) {
                fmt.append(parte.toLowerCase());
            } else {
                fmt.append(parte.substring(0, 1).toUpperCase()).
                        append(parte.substring(1).toLowerCase());
            }

            fmt.append(" ");
        }

        return fmt.toString().trim();
    }

    public String obterPI(int casasDecimais) throws Exception {
        if (casasDecimais <= 0) {
            throw new Exception("Informe um numero vlido de casas decimais");
        }

        return PI.computePi(casasDecimais).toString();
    }

    public String[] obterFasesLua(int mes, int ano) throws Exception {

        if ((mes < 1) || (mes > 12)) {
            throw new Exception("Mes invlido");
        }

        if (ano <= 0) {
            throw new Exception("Ano invlido");
        }


        Calendar cal = Calendar.getInstance();
        cal.set(Calendar.YEAR, ano);
        cal.set(Calendar.MONTH, mes - 1);

        int diasMes = cal.getActualMaximum(Calendar.DAY_OF_MONTH);
        StringBuffer result = new StringBuffer();

        for (int i = 1; i <= diasMes; i++) {
            cal.set(Calendar.DATE, i);

            result.append(Moon.getPhaseOfMoon(cal)).
                    append(";");
        }

        return result.toString().split(";");
    }

    public String postarTwitter(String login, String senha, String status) {
        // Utiliza-se para esse servio o JTwitter
        // que pode ser baixado de http://www.winterwell.com/software/jtwitter.php
        // O jar jtwitter.jar escontra-se na pasta lib

        Twitter twitter = new Twitter(login, senha);
        twitter.setStatus(status);
        return "OK";
    }


    /*
    public static void main(String[] args) throws Exception {
        Servicos sv = new Servicos();
        String[] result = sv.obterFasesLua(5, 2009);

        for (String fase: result) {
            System.out.println(fase);
        }
    }
    */
}
