unit uConsEvento;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, uFrmModeloCons, DBCtrls, Grids, DBGrids, StdCtrls, Buttons, ExtCtrls;

type
  TfrmConsEvento = class(TfrmModeloCons)
    DBText1: TDBText;
    DBMemo1: TDBMemo;
    Label3: TLabel;
    bPresencas: TBitBtn;
    bPresentes: TBitBtn;
    procedure btAlterarClick(Sender: TObject);
    procedure btCadastrarClick(Sender: TObject);
    procedure btExcluirClick(Sender: TObject);
    procedure btPesquisaClick(Sender: TObject);
    procedure btTransferirClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormShow(Sender: TObject);
    procedure bPresencasClick(Sender: TObject);
    procedure bPresentesClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmConsEvento: TfrmConsEvento;

implementation

uses uDM, uLib, uCadEvento, uCadPresenca;

{$R *.dfm}

procedure TfrmConsEvento.bPresentesClick(Sender: TObject);
begin
  inherited;
  //verifica se tem algum evento selecionado
  if DBGrid1.DataSource.DataSet.IsEmpty then
  begin
    Alerta('Nenhum Evento Selecionado Para Visualizar Os Participantes !');
    abort;
  end;

  //lista na qry temporria os cdigos das pessoas presentes naquele evento
  dm.qryAux.Close;
  dm.qryAux.SQL.Text := 'SELECT CODPESSOA FROM PARTICIPACOES WHERE' +
    ' PRESENTE = ''T'' AND CODEVENTO = ' + dm.cdsEventoCODEVENTO.AsString;
  dm.qryAux.Open;
  //se no encontro ningum, alerta o usurio
  if dm.qryAux.IsEmpty then
  begin
    dm.qryAux.Close;
    Informacao('Nenhuma Presena Registrada Para Este Evento !');
    exit;
  end;

  //cria a tela de presenas
  frmCadPresenca := TfrmCadPresenca.Create(Application);
  try
    //ajusta o caption
    frmCadPresenca.Caption := 'Visualizao de Participantes';
    //oculta o painel de digitao
    frmCadPresenca.pDigitacao.Visible := False;
    //para cada presente no evento, chama o procedimento que
    //insere a pessoa no cds
    while not dm.qryAux.Eof do
    begin
      frmCadPresenca.eParticipante.Text := dm.qryAux.FieldByName('CODPESSOA').AsString;
      frmCadPresenca.RegistraPresenca;
      dm.qryAux.Next;
    end;
    dm.qryAux.Close;
    //exibe o form com a listagem das pessoas presentes
    frmCadPresenca.ShowModal;
  finally
    frmCadPresenca.Release;
  end;
end;

procedure TfrmConsEvento.bPresencasClick(Sender: TObject);
begin
  inherited;
  //valida se foi o evento foi selecionado
  if DBGrid1.DataSource.DataSet.IsEmpty then
  begin
    Alerta('Nenhum Evento Selecionado Para Registrar as Presenas !');
    abort;
  end;

  //chama o formulrio que registrar as presenas
  frmCadPresenca := TfrmCadPresenca.Create(Application);
  try
    frmCadPresenca.ShowModal;
  finally
    frmCadPresenca.Release;
  end;
end;

procedure TfrmConsEvento.btAlterarClick(Sender: TObject);
begin
  inherited;
  AbreForm(TfrmCadEvento, frmCadEvento);
end;

procedure TfrmConsEvento.btCadastrarClick(Sender: TObject);
begin
  inherited;
  with dm do Inserir(cdsEvento);
  AbreForm(TfrmCadEvento, frmCadEvento);
end;

procedure TfrmConsEvento.btExcluirClick(Sender: TObject);
begin
  inherited;
  with dm do Excluir(cdsEvento, 'NOME');
end;

procedure TfrmConsEvento.btPesquisaClick(Sender: TObject);
begin
  with dm.cdsEvento do
  begin
    Close;
    Params.ParamByName('NOME').AsString := edtPesquisa.Text+'%';
    Open;
  end;
  inherited;
end;

procedure TfrmConsEvento.btTransferirClick(Sender: TObject);
begin
  CodEvento := dm.cdsEventoCODEVENTO.AsInteger;
  inherited;
end;

procedure TfrmConsEvento.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  with dm.cdsEvento do
  begin
    Params.ParamByName('NOME').Clear;
    Close;
  end;
  inherited;
end;

procedure TfrmConsEvento.FormShow(Sender: TObject);
begin
  inherited;
  btPesquisa.Click;
end;

end.
